<template>
  <div class="row mt-3">
    <div class="col-10"></div>
    <div class="col-2 text-end px-2">
      <button type="button" class="btn btn-secondary mx-1 mt-4 p-2 mb-4  fs-7" @click="goToFormularioEditar()">
        <i class="bi bi-plus-square mx-1 p-0  fs-7"></i> NUEVO
      </button>
    </div>
  </div>
  <table class="table  table-striped" v-if="topesStore.listadoTopes.length > 0">
    <thead>
      <tr>
        <th scope="col">Fecha Desde</th>
        <th scope="col">Fecha Hasta</th>
        <th scope="col">Monto Minimo</th>
        <th scope="col">Monto Maximo</th>
        <th scope="col">Observaciones</th>
        <th scope="col">Acciones</th>
      </tr>
    </thead>
    <tbody>
      <tr v-for="topes in topesStore.listadoTopes" :key="topes.id_becariocupo">
        <td v-text="formatDate(topes.vigencia_desde)"></td>
        <td v-text="formatDate(topes.vigencia_hasta)"></td>
        <td v-text="'$' + formatPrice(topes.monto_min)"></td>
        <td v-text="'$' + formatPrice(topes.monto_max)"></td>
        <td v-text="topes.descripcion"></td>
        <td>
          <!--EDITAR  -->
          <router-link alt="Editar Tope" title="Editar Tope" :to="{
            name: 'editar-topes',
            params: { id: topes.id_becariocupo },
          }">
            <button class="btn btn-principal btn-sm pt-0 pb-0 px-1 mb-2 mt-0 mx-1  fs-5" alt="Editar" title="Editar">
              <i class="bi bi-pencil-square text-light"></i>

            </button>
          </router-link>
          <!-- BORRAR -->
          <button  class="btn btn-borrar-table  mx-2 text-uppercase p-0 px-2 fs-5 mb-2 mt-0" alt="Borrar" title="Borrar"
            @click="borrar(topes.id_becariocupo)">
            <i class="fa-solid fa-trash-can"></i>
          </button>

        </td>
      </tr>
    </tbody>
  </table>
  <div v-else class="alert alert-secondary" role="alert">
    No hay elementos para mostrar
  </div>
</template>
  
<script setup lang="ts">

//librerias
import { useRouter } from "vue-router";
import { loading, urlApi } from "@/shared.js";
import http from "@/http";
import Swal from "sweetalert2/dist/sweetalert2.js";
import type { SweetAlertOptions } from "sweetalert2";
//import { AxiosError } from "axios";
import type { AxiosError } from "axios";
import { DateTime } from "luxon";
//store
import { useTopesStore } from "@/stores/Topes/topes";
import { useConfigStore } from "@/stores/configgral";


const router = useRouter();
const topesStore = useTopesStore();
const configStore = useConfigStore()

function formatDate(date: string | null) {
  if (date != null) {
    // return moment(date).format("DD/MM/YYYY");
    return DateTime.fromISO(date).toLocaleString();
  }
}


function formatPrice(value: any) {
  let val = (value / 1).toFixed(2).replace('.', ',')
  return val.toString().replace(/\B(?=(\d{3})+(?!\d))/g, ".")
}


function goToFormularioEditar() {
  router.push({
    name: "editar-topes",
  });
}


function borrar(id_benef_cupo: Number) {
  const swal_error: SweetAlertOptions<any, any> = {
    icon: "error",
    title: "Error",
    html: "",
  }

  Swal.fire({
    icon: "question",
    title: "Confirmaci&oacute;n",
    html: "¿Confirma la eliminaci&oacute;n del Cupo? Esta acci&oacute;n no podr&aacute; ser revertida.",
    showCancelButton: true,
    confirmButtonColor: "#3085d6",
    cancelButtonColor: "#d33",
    confirmButtonText: "Confirmar",
    cancelButtonText: "Cancelar",
  }).then(async (result) => {
    if (result.isConfirmed) {
      loading.show();
      var rta = await http.post(urlApi + "deleteCupoBecario", {
        id_becariocupo: id_benef_cupo,
      }).then(async () => {
        var anio = configStore.listadoPeriodoActivo[0]?.anioActivo;
        await topesStore.updateListadoTopes({
          id_becario_cupo: null,
          fecha_desde: anio + "-03-01",
          fecha_hasta: anio + "-12-31",
        });
        Swal.fire({
          icon: "success",
          text: "Se Borro el Tope.",
        })
        loading.hide();
      }).catch(function (error: AxiosError<string, any>) {
        if (error.response) {
          // Request made and server responded
          swal_error.html = error.response.data;
          console.log("Error: request made and server responded");
          console.log(swal_error.html);
          console.log(error.response);
        } else if (error.request) {
          // The request was made but no response was received
          swal_error.html =
            "Error desconocido. Por favor, avise al Administrador.";
          console.log("Error: the request was made but no response was received");
          console.log(error.request);
        } else {
          // Something happened in setting up the request that triggered an Error
          swal_error.html =
            "Error desconocido. Por favor, avise al Administrador.";
          console.log(
            "Error: something happened in setting up the request that triggered an error"
          );
          console.log(error);
        }
        loading.hide();
        Swal.fire(swal_error);
      });
    }
  });
}

</script>
  